unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, regmashine, ExtCtrls;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    memo_program: TMemo;
    Button1: TButton;
    Button2: TButton;
    GroupBox1: TGroupBox;
    lst_mem1: TListBox;
    Label2: TLabel;
    lst_mem2: TListBox;
    lab_mem1: TLabel;
    edt_mem: TEdit;
    lab_mem2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    panel_current: TPanel;
    panel_akku: TPanel;
    panel_instruction: TPanel;
    Button3: TButton;
    Button4: TButton;
    edt_time: TEdit;
    Label5: TLabel;
    Timer: TTimer;
    procedure edt_memChange(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure edt_timeChange(Sender: TObject);
  private
    { Private-Deklarationen }
    reg:TRegMashine;
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.edt_memChange(Sender: TObject);
begin
  reg.memory_separation:=strToInt(edt_mem.text);
  lab_mem2.caption:='0x'+IntToHex(reg.memory_separation, 3)+' - 0xFFF';
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  reg.destroy;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  reg:=TRegMashine.create(lst_mem1, lst_mem2);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  reg.Parse(memo_program.lines);
  reg.InitializeView;
  panel_akku.Caption:='0x'+inttohex(reg.akku, 4);
  panel_current.Caption:='0x'+inttohex(reg.CurrentInstruction, 3);
  panel_instruction.Caption:=reg.CurrentInstructionStr;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  TimerTimer(Sender);
end;

procedure TForm1.TimerTimer(Sender: TObject);
begin
  screen.Cursor:=crHourGlass;
  reg.Step;
  lst_mem1.Update;
  lst_mem2.Update;
  panel_akku.Caption:='0x'+inttohex(reg.akku, 4);
  panel_current.Caption:='0x'+inttohex(reg.CurrentInstruction, 3);
  panel_instruction.Caption:=reg.CurrentInstructionStr;
  screen.Cursor:=crDefault;
  application.ProcessMessages;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  timer.interval:=strtoint(edt_time.text);
  timer.Enabled:=true;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  timer.Enabled:=false;
end;

procedure TForm1.edt_timeChange(Sender: TObject);
begin
  timer.interval:=strtoint(edt_time.text);
end;

end.
